nightplotTileTraceDefaults <- function(x=NULL,
                                       y=NULL,
                                       top=NULL,
                                       right=NULL,
                                       xlower=NULL,
                                       xupper=NULL,
                                       ylower=NULL,
                                       yupper=NULL,
                                       toplower=NULL,
                                       topupper=NULL,
                                       rightlower=NULL,
                                       rightupper=NULL,
                                       truex=NULL,
                                       truey=NULL,
                                       truetop=NULL,
                                       trueright=NULL,
                                       attachToTop=NULL,
                                       attachToRight=NULL,
                                       simulates=NULL,
                                       factors=c("x","y","top","right"),
                                       xdatalimits=c("x","hlower","hupper","truex"),
                                       ydatalimits=c("y","lower","upper","truey"),
                                       xtransform=c("x","hlower","hupper","truex"),
                                       ytransform=c("y","lower","upper","truey"),
                                       graphic="nightplot",
                                       plot=NULL,
                                       layer=10,
                                       fit=NULL,
                                       upper=NULL,
                                       lower=NULL,
                                       se=NULL,
                                       markers=TRUE,
                                       labels=NULL,
                                       labelsxoffset=0,
                                       labelsyoffset=0,
                                       color=color,
                                       fill="transparent",
                                       col="red",
                                       lty="solid",
                                       lwd=2,
                                       cex=1,
                                       fontsize=12,
                                       lineheight=1.2,
                                       font=1,
                                       fontfamily="",
                                       fontface="plain",
                                       alpha=0.8,                   # only if pdf
                                       lineend="round",
                                       linejoin="round",
                                       linemitre=10,
                                       lex=1,
                                       pch="*",
                                       size=1,
                                       addArrow=FALSE,
                                       angleArrow=30,
                                       lengthArrow=unit(0.25, "inches"),
                                       endsArrow="last",
                                       typeArrow="open",
                                       just="centre",
                                       hjust=NULL,
                                       vjust=NULL,
                                       rot=0,
                                       check.overlap=FALSE,
                                       clip="on",
                                       connect=FALSE,
                                       boundtype=NULL, 
                                       bw=FALSE,
                                       arcsegments=15,
                                       incr=0.0000001
                                       ) {

    fitdefault <- list(method=NULL,
                      ci=0.95,
                      mark="shaded",
                      col="yellow"                      
                      )

    cidefault <- list(levels=c(0.95),
                      mark=c("dashed")
                      )

    color <- list(data=NULL,
                  bins=NULL,
                  breaks=NULL,
                  colorset="sequential",# rainbow, diverge, heatmap, terrain, categories
                  hue=NULL,
                  chroma=NULL,
                  luminance=NULL,
                  power=NULL,
                  gamma=2.4,
                  fixup=TRUE
                  )

    defaults <- list(x=x,
                     y=y,
                     top=top,
                     right=right,
                     xlower=xlower,
                     xupper=xupper,
                     ylower=ylower,
                     yupper=yupper,
                     toplower=toplower,
                     topupper=topupper,
                     rightlower=rightlower,
                     rightupper=rightupper,
                     truex=truex,
                     truey=truey,
                     truetop=truetop,
                     trueright=trueright,
                     attachToTop=attachToTop,
                     attachToRight=attachToRight,
                     simulates=simulates,
                     factors=factors,
                     xdatalimits=xdatalimits,
                     ydatalimits=ydatalimits,
                     xtransform=xtransform,
                     ytransform=ytransform,
                     cidefault=cidefault,
                     graphic=graphic,
                     plot=plot,
                     layer=layer,
                     fitdefault=fitdefault,
                     upper=upper,
                     lower=lower,
                     se=se,
                     markers=markers,
                     labels=labels,
                     labelsxoffset=labelsxoffset,
                     labelsyoffset=labelsyoffset,
                     color=color,
                     fill=fill,
                     col=col,
                     lty=lty,
                     lwd=lwd,
                     cex=cex,
                     fontsize=fontsize,
                     lineheight=lineheight,
                     font=font,
                     fontfamily=fontfamily,
                     fontface=fontface,
                     alpha=alpha,
                     lineend=lineend,
                     linejoin=linejoin,
                     linemitre=linemitre,
                     lex=lex,
                     pch=pch,
                     size=size,
                     addArrow=addArrow,
                     angleArrow=angleArrow,
                     lengthArrow=lengthArrow,
                     endsArrow=endsArrow,
                     typeArrow=typeArrow,
                     just=just,
                     hjust=hjust,
                     vjust=vjust,
                     rot=rot,
                     check.overlap=check.overlap,
                     clip=clip,
                     connect=connect,
                     boundtype=boundtype,
                     bw=bw,
                     arcwegments=arcsegments,
                     incr=incr
                     
                     )
    
    defaults

}
    


